



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HDU  6022---MG loves set（K-D树）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HDU  6022---MG loves set（K-D树）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 08:16:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="http://acm.hdu.edu.cn/showproblem.php?pid=6022" rel="external nofollow noreferrer">题目链接</a></p>
<div><strong>Problem Description</strong></div>
<div>MG is an intelligent boy. One day he was challenged by the famous master called Douer:&nbsp;<br />if the sum of the square of every element in a set is less than or equal to the square of the sum of all the elements, then we regard this set as &rdquo;A Harmony Set&rdquo;.&nbsp;<br />Now we give a set with&nbsp;n&nbsp;different elements, ask you how many nonempty subset is &ldquo;A Harmony Set&rdquo;.<br />MG thought it very easy and he had himself disdained to take the job. As a bystander, could you please help settle the problem and calculate the answer?</div>
<div>&nbsp;</div>
<div><strong>Input</strong></div>
<div>The first line is an integer&nbsp;T&nbsp;which indicates the case number.(1&lt;=T&lt;=10)<br />And as for each case, there are&nbsp;1&nbsp;integer&nbsp;n&nbsp;in the first line which indicate the size of the set(n&lt;=30).<br />Then there are&nbsp;n&nbsp;integers&nbsp;V&nbsp;in the next line, the x-th integer means the x-th element of the set(0&lt;=|V|&lt;=100000000).</div>
<div><strong>Output</strong></div>
<div>As for each case, you need to output a single line.<br />There should be one integer in the line which represents the number of &ldquo;Harmony Set&rdquo;.&nbsp;</div>
<div><strong>Sample Input</strong></div>
<div>
<div>3</div>
<div>4
</div>
<div>1 2 3 4
</div>
<div>5
</div>
<div>1 -1 2 3 -3
</div>
<div>6
</div>
<div>0 2 4 -4 -5 8</div>
</div>
<div>&nbsp;</div>
<div><strong>Sample Output</strong></div>
<div>
<div>15</div>
<div>12</div>
<div>25</div>
<div>&nbsp;</div>
<div>题意：</div>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/716722/201704/716722-20170409214451628-1549861991.png" /></p>
<p>思路：</p>
<p>看到题目数据的范围n&lt;=30 ，枚举考虑每一个子集肯定会超时，所以这个办法不行了。怎么样降低复杂度呢？</p>
<p>先化简一下，设子集为{x，y，z}满足题目要求，则x*x+y*y+z*z&lt;=(x+y+z)*(x+y+z) 即xy+yz+xz&gt;=0 &nbsp;,所以本题就是求一个集合有多少非空子集满足集合中元素两两乘积的和大于等于0；</p>
<p>巧妙地思想：把集合分成前后两半，设前一半集合的任意一个子集的和为Xi 两两之间乘积的和为Yi ,后一半集合的任意一个子集的和为Xj 两两之间乘积的和为Yj 可以发现(a+b)*(c+d)+ab+cd&gt;=0是子集{a,b,c,d}满足题意的要求，那么Xi*Xj+Yi+Yj&gt;=0就是判断当前由这两个子集合起来得到的子集是否满足题意的要求。最后用K-D树优化即可。</p>
<p>官方题解如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/716722/201704/716722-20170409214534128-1823546040.png" /></p>
<p>代码如下：</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;cstdio&gt;<br />
using namespace std;<br />
typedef long long LL;<br />
const int N=;<br />
LL a[];<br />
int flag[*N];<br />
int idx;

struct Node<br />
{<br />
    LL f[];<br />
    LL mx[];<br />
    LL mn[];<br />
    int size;<br />
    bool operator&lt;(const Node&amp; s)const<br />
    { return f[idx]&lt;s.f[idx]; }<br />
}A[N],B[N],tr[*N];

void update(int i)<br />
{<br />
    int s=;<br />
    if(flag[i&lt;&lt;])<br />
    {<br />
        for(int k=;k&lt;=;k++)<br />
        {<br />
            if(tr[i&lt;&lt;].mn[k]&lt;tr[i].mn[k]) tr[i].mn[k]=tr[i&lt;&lt;].mn[k];<br />
            if(tr[i&lt;&lt;].mx[k]&gt;tr[i].mx[k]) tr[i].mx[k]=tr[i&lt;&lt;].mx[k];<br />
        }<br />
        s+=tr[i&lt;&lt;].size;<br />
    }<br />
    if(flag[i&lt;&lt;|])<br />
    {<br />
        for(int k=;k&lt;=;k++)<br />
        {<br />
            if(tr[i&lt;&lt;|].mn[k]&lt;tr[i].mn[k]) tr[i].mn[k]=tr[i&lt;&lt;|].mn[k];<br />
            if(tr[i&lt;&lt;|].mx[k]&gt;tr[i].mx[k]) tr[i].mx[k]=tr[i&lt;&lt;|].mx[k];<br />
        }<br />
        s+=tr[i&lt;&lt;|].size;<br />
    }<br />
    tr[i].size=s;<br />
}

void build(int l,int r,int i,int deep)<br />
{<br />
    if(l&gt;r) return;<br />
    int mid=(l+r)&gt;&gt;;<br />
    idx=deep;<br />
    flag[i]=;<br />
    flag[i&lt;&lt;]=; flag[i&lt;&lt;|]=;

    nth_element(B+l,B+mid,B+r+);<br />
    for(int k=;k&lt;=;k++)<br />
       tr[i].mx[k]=tr[i].mn[k]=tr[i].f[k]=B[mid].f[k];

    build(l,mid-,i&lt;&lt;,-deep);<br />
    build(mid+,r,i&lt;&lt;|,-deep);<br />
    update(i);<br />
}<br />
int check(LL x1,LL y1,LL x2,LL y2)<br />
{<br />
    if(x1*x2+y1+y2&gt;=) return ;<br />
    return ;<br />
}<br />
int count(Node p,int i)<br />
{<br />
    int re=;<br />
    re+=check(tr[i].mn[],tr[i].mn[],p.f[],p.f[]);<br />
    re+=check(tr[i].mn[],tr[i].mx[],p.f[],p.f[]);<br />
    re+=check(tr[i].mx[],tr[i].mn[],p.f[],p.f[]);<br />
    re+=check(tr[i].mx[],tr[i].mx[],p.f[],p.f[]);<br />
    return re;<br />
}<br />
int query(Node p,int i)<br />
{<br />
    if(!flag[i]) return ;<br />
    if(count(p,i)==) return tr[i].size;<br />
    int re=check(p.f[],p.f[],tr[i].f[],tr[i].f[]);<br />
    if(count(p,i&lt;&lt;)) re+=query(p,i&lt;&lt;);<br />
    if(count(p,i&lt;&lt;|)) re+=query(p,i&lt;&lt;|);<br />
    return re;<br />
}

int main()<br />
{<br />
    int T;<br />
    cin&gt;&gt;T;<br />
    while(T--)<br />
    {<br />
        int n;<br />
        scanf("%d",&amp;n);<br />
        for(int i=;i&lt;=n;i++)<br />
          scanf("%lld",&amp;a[i]);<br />
        int mid=n/;<br />
        int tt=(&lt;&lt;mid);<br />
        int tot1=,tot2=;<br />
        for(int i=;i&lt;=tt-;i++)<br />
        {<br />
            A[tot1].f[]=;<br />
            A[tot1].f[]=;<br />
            for(int k=;(&lt;&lt;(k-))&lt;tt;k++)<br />
            {<br />
                if((&lt;&lt;(k-))&amp;i)<br />
                {<br />
                    A[tot1].f[]+=A[tot1].f[]*a[k];<br />
                    A[tot1].f[]+=a[k];<br />
                }<br />
            }<br />
            tot1++;<br />
        }<br />
        int tt2=&lt;&lt;n;<br />
        for(int i=;i&lt;tt2;i+=tt)<br />
        {<br />
            B[tot2].f[]=;<br />
            B[tot2].f[]=;<br />
            for(int k=mid+;(&lt;&lt;(k-))&lt;tt2;k++)<br />
            {<br />
                if((&lt;&lt;(k-))&amp;i)<br />
                {<br />
                    B[tot2].f[]+=B[tot2].f[]*a[k];<br />
                    B[tot2].f[]+=a[k];<br />
                }<br />
            }<br />
            tot2++;<br />
        }<br />
        /*for(int i=0;i&lt;tot1;i++)<br />
        cout&lt;&lt;A[i].f[0]&lt;&lt;" "&lt;&lt;A[i].f[1]&lt;&lt;endl;<br />
        cout&lt;&lt;"-----------------"&lt;&lt;endl;<br />
        for(int i=0;i&lt;tot2;i++)<br />
        cout&lt;&lt;B[i].f[0]&lt;&lt;" "&lt;&lt;B[i].f[1]&lt;&lt;endl;*/<br />
        build(,tot2-,,);<br />
        int ans=-;<br />
        for(int i=;i&lt;tot1;i++)<br />
        {<br />
            ans+=query(A[i],);<br />
        }<br />
        printf("%d\n",ans);<br />
    }<br />
    return ;<br />
}</pre>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq415njq.html">关于system函数的安全性漏洞</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm1pxz9.html">hue安装与部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vp0rm8.html">springmvc常用注解之&commat;Controller和&commat;RequestMapping</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yk5x3q.html">arcengine C&num; 读写lyr（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okrex19.html">ccf集合竞价</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1d2039.html">极致精简的fragment实现导航栏切换demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojodr5q.html">JFinal极速开发框架使用笔记&lpar;二&rpar;  两个问题，一个发现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jvr3o8.html">POJ 1704 Georgia and Bob &lbrack;阶梯Nim&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkpole8.html">带着新人学springboot的应用05（springboot&plus;RabbitMQ 上）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gx6d6q.html">java利用反射交换两个对象中的字段相同的字段值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlljd61q.html">git master 回滚代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/960lglv9.html">数据持久化系列之Mysql</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1pw3eq.html">原创&colon;vsphere概念深入系列三：vSphere命令行管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5r0emq.html">ubuntu14&period;04 cpu-ssd</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd777e9.html">Android自定义View学习笔记（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4jp0lq.html">Jetpack 架构组件 Lifecycle 生命周期 MD</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2ojkd8.html">jquery 之 extend的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk42y18.html">Js获取iframe子页面全局变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve3e7o9.html">python字典键值对转化为相应的变量名和变量值</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kyojvq.html">OSG学习：裁剪变换（1）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kjrnp59.html">hive的常用操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2302z9.html">Zabbix告警脚本-微信</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5k04rq.html">Python自动化测试用例设计--测试类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2rwn0q.html">dump、load和dumps、loads的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy052gq.html">106&period; Construct Binary Tree from Inorder and Postorder Traversal根据后中序数组恢复出原来的树</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv4yxk8.html">计算a月的第b个星期c</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g7d76q.html">拜托！面试请不要再问我Spring Cloud底层原理&lbrack;z&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zye32d9.html">echart&period;js在vue中使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ygolq.html">&lpar;百度&rpar;centos7上安装apache指南</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2rr62q.html">注解&commat;ResponseBody的作用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
